Package: filehash
Version: 2.4-6
Depends: R (>= 3.0.0)
Imports: digest, methods
Collate: filehash.R filehash-DB1.R filehash-RDS.R coerce.R dump.R
        hash.R queue.R stack.R zzz.R
Title: Simple Key-Value Database
Author: Roger D. Peng <roger.peng@austin.utexas.edu>
Maintainer: Roger D. Peng <roger.peng@austin.utexas.edu>
Description: Implements a simple key-value style database where character string keys
  are associated with data values that are stored on the disk. A simple interface is provided for inserting,
  retrieving, and deleting data from the database. Utilities are provided that allow 'filehash' databases to be
  treated much like environments and lists are already used in R. These utilities are provided to encourage
  interactive and exploratory analysis on large datasets. Three different file formats for representing the
  database are currently available and new formats can easily be incorporated by third parties for use in the
  'filehash' framework.
License: GPL (>= 2)
URL: https://github.com/rdpeng/filehash
RoxygenNote: 7.3.1
Encoding: UTF-8
NeedsCompilation: yes
Packaged: 2024-06-25 13:57:00 UTC; rp34949
Repository: CRAN
Date/Publication: 2024-06-25 21:20:10 UTC
Built: R 4.6.0; aarch64-apple-darwin23; 2026-04-25 16:40:38 UTC; unix
Archs: filehash.so.dSYM

##########################################################################
## Copyright (C) 2006-2023, Roger D. Peng <roger.peng @ austin.utexas.edu>
##     
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.
## 
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
## 
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
## 02110-1301, USA
##########################################################################

#' @importFrom digest digest
sha1 <- function(object, skip = 14L) {
        bytes <- serialize(object, NULL)
        digest(bytes, algo = "sha1", skip = skip, serialize = FALSE)
}


#' @importFrom digest digest
sha1_file <- function(filename, skip = 0L) {
	digest(filename, algo = "sha1", file = TRUE)
}

##########################################################################
## Copyright (C) 2006-2023, Roger D. Peng <roger.peng @ austin.utexas.edu>
##     
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.
## 
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
## 
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
## 02110-1301, USA
##########################################################################

.onLoad <- function(lib, pkg) {
        assign("defaultType", "DB1", .filehashOptions)

        for(type in c("DB1", "RDS")) {
                cname <- paste("create", type, sep = "")
                iname <- paste("initialize", type, sep = "")
                r <- list(create = get(cname, mode = "function"),
                          initialize = get(iname, mode="function"))
                assign(type, r, .filehashFormats)
        }
}

.onAttach <- function(lib, pkg) {
        dcf <- read.dcf(file.path(lib, pkg, "DESCRIPTION"))
        msg <- gettextf("%s: %s (%s)", dcf[, "Package"], dcf[, "Title"],
                        as.character(dcf[, "Version"]))
        packageStartupMessage(paste(strwrap(msg), collapse = "\n"))
}

.filehashOptions <- new.env()

.filehashFormats <- new.env()

##########################################################################
## Copyright (C) 2006-2023, Roger D. Peng <roger.peng @ austin.utexas.edu>
##     
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.
## 
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
## 
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
## 02110-1301, USA
##########################################################################

#' A Queue Class
#' 
#' A queue implementation using a \code{filehash} database
#' 
#' @details Objects can be created by calls of the form \code{new("queue", ...)} or by calling \code{createQ}.  Existing queues can be initialized with \code{initQ}.
#' 
#' @slot queue Object of class \code{"filehashDB1"}
#' @slot name Object of class \code{"character"}: the name of the queue (default is the file name in which the queue data are stored)
#' @exportClass queue
setClass("queue",
         representation(queue = "filehashDB1",
                        name = "character")
         )

#' @param filename name of queue file
#' 
#' @return \code{createQ} and \code{initQ} return a \code{queue} object
#' @export
#' @describeIn queue Create a file-based queue object
createQ <- function(filename) {
        dbCreate(filename, "DB1")
        queue <- dbInit(filename, "DB1")
        dbInsert(queue, "head", NULL)
        dbInsert(queue, "tail", NULL)

        new("queue", queue = queue, name = filename)
}

#' @export
#' @describeIn queue Intialize an existing queue object
initQ <- function(filename) {
        new("queue",
            queue = dbInit(filename, "DB1"),
            name = filename)
}

## Public

#' @describeIn queue Return (and remove) the top element of a queue
setGeneric("pop", function(db, ...) standardGeneric("pop"))

#' @describeIn queue Push an R object on to the tail of a queue
setGeneric("push", function(db, val, ...) standardGeneric("push"))

#' @describeIn queue Check if a queue is empty or not
setGeneric("isEmpty", function(db, ...) standardGeneric("isEmpty"))

#' @describeIn queue Return the top of the queue
setGeneric("top", function(db, ...) standardGeneric("top"))


#' @exportMethod show
#' @describeIn queue Print a queue object
#' @param object a queue object
setMethod("show", "queue",
          function(object) {
                  cat(gettextf("<queue: %s>\n", object@name))
                  invisible(object)
          })


################################################################################
## Methods

setMethod("lockFile", "queue",
          function(db, ...) {
                  paste(db@name, "qlock", sep = ".")
          })

#' @exportMethod push
#' @describeIn queue adds an element to the tail ("bottom") of the queue
#' @param db a queue object
#' @param val an R object to be added to the tail queue
#' @param ... arguments passed to other methods
setMethod("push", c("queue", "ANY"), function(db, val, ...) {
        ## Create a new tail node
        node <- list(value = val,
                     nextkey = NULL)
        key <- sha1(node)

        createLockFile(lockFile(db))
        on.exit(deleteLockFile(lockFile(db)))

        if(isEmpty(db))
                dbInsert(db@queue, "head", key)
        else {
                ## Convert tail node to regular node
                tailkey <- dbFetch(db@queue, "tail")
                oldtail <- dbFetch(db@queue, tailkey)
                oldtail$nextkey <- key
                dbInsert(db@queue, tailkey, oldtail)
        }
        ## Insert new node and point tail to new node
        dbInsert(db@queue, key, node)
        dbInsert(db@queue, "tail", key)
})

#' @exportMethod isEmpty
#' @describeIn queue returns \code{TRUE}/\code{FALSE} depending on whether there are elements in the queue.
setMethod("isEmpty", "queue", function(db) {
        is.null(dbFetch(db@queue, "head"))
})

#' @exportMethod top
#' @describeIn queue returns the value of the "top" (i.e. head) of the queue; an error is signaled if the queue is empty
setMethod("top", "queue", function(db, ...) {
        createLockFile(lockFile(db))
        on.exit(deleteLockFile(lockFile(db)))

        if(isEmpty(db))
                stop("queue is empty")
        h <- dbFetch(db@queue, "head")
        node <- dbFetch(db@queue, h)
        node$value
})

#' @exportMethod pop
#' @describeIn queue returns the value of the "top" (i.e. head) of the queue and subsequently removes that element from the queue; an error is signaled if the queue is empty
#' @param db a queue object
setMethod("pop", "queue", function(db, ...) {
        createLockFile(lockFile(db))
        on.exit(deleteLockFile(lockFile(db)))

        if(isEmpty(db))
                stop("queue is empty")
        h <- dbFetch(db@queue, "head")
        node <- dbFetch(db@queue, h)
        dbInsert(db@queue, "head", node$nextkey)
        dbDelete(db@queue, h)
        node$value
})

######################################################################
## Copyright (C) 2006, Roger D. Peng <rpeng@jhsph.edu>
##     
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.
## 
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
## 
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
## 02110-1301, USA
#####################################################################

################################################################################
## Class 'filehashRDS'

setClass("filehashRDS",
         representation(dir = "character"),
         contains = "filehash"
         )

setValidity("filehashRDS",
            function(object) {
                    if(length(object@dir) != 1)
                            return("only one directory should be set in 'dir'")
                    if(!file.exists(object@dir))
                            return(gettextf("directory '%s' does not exist",
                                            object@dir))
                    TRUE
            })

createRDS <- function(dbName) {
        if(!file.exists(dbName)) {
                status <- dir.create(dbName)

                if(!status)
                        stop(gettextf("unable to create database directory '%s'",
                                      dbName))
        }
        else
                message(gettextf("database '%s' already exists", dbName))
        TRUE
}

initializeRDS <- function(dbName) {
        ## Trailing '/' causes a problem in Windows?
        dbName <- sub("/$", "", dbName, perl = TRUE)
        new("filehashRDS", dir = normalizePath(dbName),
            name = basename(dbName))
}

## For case-insensitive file systems, objects with the same name but
## differ by capitalization might get clobbered.  `mangleName()'
## inserts a "@" before each capital letter and `unMangleName()'
## reverses the operation.

mangleName <- function(oname) {
        if(any(grep("@",oname,fixed=TRUE))) 
                stop("RDS format cannot cope with objects with @ characters",
                        " in their names")
        gsub("([A-Z])", "@\\1", oname, perl = TRUE)
}

unMangleName <- function(mname) {
        gsub("@", "", mname, fixed = TRUE)
}

## Function for mapping a key to a path on the filesystem
setGeneric("objectFile", function(db, key) standardGeneric("objectFile"))
setMethod("objectFile", signature(db = "filehashRDS", key = "character"),
          function(db, key) {
                  file.path(db@dir, mangleName(key))
          })

################################################################################
## Interface functions

setMethod("dbInsert",
          signature(db = "filehashRDS", key = "character", value = "ANY"),
          function(db, key, value, safe = TRUE, ...) {
                  writefile <- if(safe)
                          tempfile()
                  else
                          objectFile(db, key)
                  con <- gzfile(writefile, "wb")

                  writestatus <- tryCatch({
                          serialize(value, con)
                  }, condition = function(cond) {
                          cond
                  }, finally = {
                          close(con)
                  })
                  if(inherits(writestatus, "condition"))
                          stop(gettextf("unable to write object '%s'", key))
                  if(!safe)
                          return(invisible(!inherits(writestatus, "condition")))

                  cpstatus <- file.copy(writefile, objectFile(db, key),
                                        overwrite = TRUE)

                  if(!cpstatus)
                          stop(gettextf("unable to insert object '%s'", key))
                  else {
                          rmstatus <- file.remove(writefile)

                          if(!rmstatus)
                                  warning("unable to remove temporary file")
                  }
                  invisible(cpstatus)
          })

setMethod("dbFetch", signature(db = "filehashRDS", key = "character"),
          function(db, key, ...) {
                  ## Create filename from key
                  ofile <- objectFile(db, key)
                  ## Open connection
                  val <- tryCatch({
                          con<-gzfile(ofile)
                          # note it is necessary to split creating and opening
                          # the connection into two steps so that the connection
                          # can be closed/destroyed successfully if ofile does 
                          # not exist (avoiding connection leaks).
                          open(con,"rb")
                          ## Read data
                          unserialize(con)
                  }, condition = function(cond) {
                          cond
                  }, finally = {
                          close(con)
                  })
                  if(inherits(val, "condition")) 
                          stop(gettextf("unable to obtain value for key '%s'",
                                        key))
                  val
          })

setMethod("dbMultiFetch",
          signature(db = "filehashRDS", key = "character"),
          function(db, key, ...) {
                  r <- lapply(key, function(k) dbFetch(db, k))
                  names(r) <- key
                  r
          })

setMethod("dbExists", signature(db = "filehashRDS", key = "character"),
          function(db, key, ...) {
                  key %in% dbList(db)
          })

setMethod("dbList", "filehashRDS",
          function(db, ...) {
                  ## list all keys/files in the database
                  fileList <- dir(db@dir, all.files = TRUE, full.names = TRUE)
                  use <- !file.info(fileList)$isdir
                  fileList <- basename(fileList[use])

                  unMangleName(fileList)
          })

setMethod("dbDelete", signature(db = "filehashRDS", key = "character"),
          function(db, key, ...) {
                  ofile <- objectFile(db, key)

                  ## remove/delete the file
                  status <- file.remove(ofile)
                  invisible(isTRUE(all(status)))
          })

setMethod("dbUnlink", "filehashRDS",
          function(db, ...) {
                  ## delete the entire database directory
                  d <- db@dir
                  status <- unlink(d, recursive = TRUE)
                  invisible(status)
          })

##########################################################################
## Copyright (C) 2006-2023, Roger D. Peng <roger.peng @ austin.utexas.edu>
##     
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.
## 
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
## 
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
## 02110-1301, USA
##########################################################################

#' Stack Class
#' 
#' A stack implementation using a \code{filehash} database
#' 
#' @details Objects can be created by calls of the form \code{new("stack", ...)} or by calling \code{createS}.  Existing queues can be initialized with \code{initS}.
#' 
#' @slot stack Object of class \code{"filehashDB1"}
#' @slot name Object of class \code{"character"}: the name of the stack (default is the file name in which the stack data are stored)
#' 
#' @exportClass stack
setClass("stack",
         representation(stack = "filehashDB1",
                        name = "character"))

#' @exportMethod show
#' @describeIn stack Print a stack object.
#' @param object a stack object
setMethod("show", "stack",
          function(object) {
                  cat(gettextf("<stack: %s>\n", object@name))
                  invisible(object)
          })

#' @param filename name of file to store stack
#' @export
#' @describeIn stack Create a filehash Stack
#' @return a stack object
createS <- function(filename) {
        dbCreate(filename, "DB1")
        stack <- dbInit(filename, "DB1")
        dbInsert(stack, "top", NULL)

        new("stack", stack = stack, name = filename)
}

#' @describeIn stack Initialize and existing filehash stack
#' @param filename name of file where stack is stored
#' @export
initS <- function(filename) {
        new("stack",
            stack = dbInit(filename, "DB1"),
             name = filename)
}


setMethod("lockFile", "stack",
          function(db, ...) {
                  paste(db@name, "slock", sep = ".")
          })

#' @exportMethod push
#' @param db a stack object
#' @param val an R object to be added to the stack
#' @param ... arguments passed to other methods
#' @describeIn stack Push an object on to the stack
setMethod("push", c("stack", "ANY"), function(db, val, ...) {
        node <- list(value = val,
                    nextkey = dbFetch(db@stack, "top"))
        topkey <- sha1(node)

        createLockFile(lockFile(db))
        on.exit(deleteLockFile(lockFile(db)))

        dbInsert(db@stack, topkey, node)
        dbInsert(db@stack, "top", topkey)
})

#' @describeIn stack Push multiple R objects on to a stack
setGeneric("mpush", function(db, vals, ...) standardGeneric("mpush"))

#' @exportMethod mpush
#' @param vals a list of R objects
#' @describeIn stack Push a list of R objects on to the stack
setMethod("mpush", c("stack", "ANY"), function(db, vals, ...) {
        if(!is.list(vals))
                vals <- as.list(vals)
        createLockFile(lockFile(db))
        on.exit(deleteLockFile(lockFile(db)))

        topkey <- dbFetch(db@stack, "top")

        for(i in seq_along(vals)) {
                node <- list(value = vals[[i]],
                             nextkey = topkey)
                topkey <- sha1(node)

                dbInsert(db@stack, topkey, node)
                dbInsert(db@stack, "top", topkey)
        }
})

#' @exportMethod isEmpty
#' @describeIn stack Indicate whether the stack is empty or not
setMethod("isEmpty", "stack", function(db, ...) {
        h <- dbFetch(db@stack, "top")
        is.null(h)
})


#' @exportMethod top
#' @describeIn stack Return the top element of the stack
setMethod("top", "stack", function(db, ...) {
        createLockFile(lockFile(db))
        on.exit(deleteLockFile(lockFile(db)))

        if(isEmpty(db))
                stop("stack is empty")
        h <- dbFetch(db@stack, "top")
        node <- dbFetch(db@stack, h)
        node$value
})

#' @exportMethod pop
#' @describeIn stack Return the top element of the stack and remove that element from the stack
setMethod("pop", "stack", function(db, ...) {
        createLockFile(lockFile(db))
        on.exit(deleteLockFile(lockFile(db)))

        if(isEmpty(db))
                stop("stack is empty")
        h <- dbFetch(db@stack, "top")
        node <- dbFetch(db@stack, h)

        dbInsert(db@stack, "top", node$nextkey)
        dbDelete(db@stack, h)
        node$value
})

##########################################################################
## Copyright (C) 2006-2023, Roger D. Peng <roger.peng @ austin.utexas.edu>
##     
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.
## 
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
## 
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
## 02110-1301, USA
##########################################################################
######################################################################
## Class 'filehash'

#' Filehash Class
#' 
#' These functions form the interface for a simple file-based key-value database (i.e. hash table).
#' 
#' @details Objects can be created by calls of the form \code{new("filehash", ...)}.
#' 
#' @slot name Object of class \code{"character"}, name of the database.
#' 
#' @useDynLib filehash,.registration = TRUE, .fixes = "C_"
#' @import methods
#' @exportClass filehash
setClass("filehash", representation(name = "character"))

setValidity("filehash", function(object) {
    if(length(object@name) == 0)
        "database name has length 0"
    else
        TRUE
})

setGeneric("dbName", function(db) standardGeneric("dbName"))

setMethod("dbName", "filehash", function(db) db@name)

#' @exportMethod show
#' @param object a filehash object
#' @describeIn filehash Print a filehash object
setMethod("show", "filehash",
          function(object) {
              if(length(object@name) == 0)
                  stop("database does not have a name")
              cat(gettextf("'%s' database '%s'\n", as.character(class(object)),
                           object@name))
          })

######################################################################

#' Register Database Format
#' 
#' @param name character, name of database format
#' @param funlist list of functions for creating and initializing a database format
#' @export
registerFormatDB <- function(name, funlist) {
    if(!all(c("initialize", "create") %in% names(funlist)))
        stop("need both 'initialize' and 'create' functions in 'funlist'")
    r <- list(list(create = funlist[["create"]],
                   initialize = funlist[["initialize"]]))
    names(r) <- name
    do.call("filehashFormats", r)
    TRUE
}

#' List and register filehash formats
#' 
#' List and register filehash backend database formats.
#'
#' @param \dots list of functions for registering a new database format
#' 
#' @details \code{filehashFormats} can be used to register new filehash backend database formats.  \code{filehashFormats} called with no arguments lists information on available formats
#' @return A list containing information on the available filehash formats
#' @export
filehashFormats <- function(...) {
    args <- list(...)
    n <- names(args)

    for(n in names(args)) 
        assign(n, args[[n]], .filehashFormats)
    current <- as.list(.filehashFormats)

    if(length(args) == 0)
        current
    else
    invisible(current)
}

######################################################################
## Create necessary database files.  On successful creation, return
## TRUE.  If the database already exists, don't do anything but return
## TRUE (and print a message).  If there's any other strange
## condition, return FALSE.

dbStartup <- function(dbName, type, action = c("initialize", "create")) {
    action <- match.arg(action)
    validFormat <- type %in% names(filehashFormats())
    
    if(!validFormat) 
        stop(gettextf("'%s' not a valid database format", type))
    formatList <- filehashFormats()[[type]]
    doFUN <- formatList[[action]]

    if(!is.function(doFUN))
        stop(gettextf("'%s' function for database format '%s' is not valid",
                      action, type))
    doFUN(dbName)
}    

setGeneric("dbCreate", function(db, ...) standardGeneric("dbCreate"))

#' @exportMethod dbCreate
#' @aliases dbCreate
#' @param db a filehash object
#' @param ... arguments passed to other methods
#' @describeIn filehash Create a filehash database
setMethod("dbCreate", "ANY",
          function(db, type = NULL, ...) {
              if(is.null(type))
                  type <- filehashOption()$defaultType

              dbStartup(db, type, "create")
          })
          
setGeneric("dbInit", function(db, ...) standardGeneric("dbInit"))

#' @exportMethod dbInit
#' @describeIn filehash Initialize an existing filehash database
#' @param type filehash database type
#' @aliases dbInit
setMethod("dbInit", "ANY",
          function(db, type = NULL, ...) {
              if(is.null(type))
                  type <- filehashOption()$defaultType
              dbStartup(db, type, "initialize")
          })

######################################################################
## Set options and retrieve list of options

#' Set Filehash Options
#' 
#' Set global filehash options
#' 
#' @param \dots name-value pairs for options
#' @details Currently, the only option that can be set is the default database type (\code{defaultType}) which can be "DB1", "RDS" or "DB". 
#' @return \code{filehashOptions} returns a list of current settings for all options.
#' 
#' @export
filehashOption <- function(...) {
    args <- list(...)
    n <- names(args)

    for(n in names(args)) 
        assign(n, args[[n]], .filehashOptions)
    current <- as.list(.filehashOptions)

    if(length(args) == 0)
        current
    else
        invisible(current)
}

######################################################################
## Load active bindings into an environment

#' Load a Database
#' 
#' Load entire database into an environment
#' 
#' @param db filehash database object
#' @param ... arguments passed to other methods
#' 
#' @details \code{dbLoad} loads objects in the database directly into the 
#' environment specified, like \code{load} does except with active bindings. 
#' \code{dbLoad} takes a second argument \code{env}, which is an 
#' environment, and the default for \code{env} is \code{parent.frame()}. 
#' 
#' @details The use of \code{makeActiveBinding} in \code{db2env} and 
#' \code{dbLoad} allows for potentially large databases to, at least 
#' conceptually, be used in R, as long as you don't need simultaneous access to 
#' all of the elements in the database.
#' 
setGeneric("dbLoad", function(db, ...) standardGeneric("dbLoad"))

#' @exportMethod dbLoad
#' @param env environment into which objects should be loaded
#' @param keys specific keys to be loaded (if NULL then all keys are loaded)
#' @describeIn dbLoad Method for filehash databases
setMethod("dbLoad", "filehash",
          function(db, env = parent.frame(2), keys = NULL, ...) {
              if(is.null(keys))
                  keys <- dbList(db)
              else if(!is.character(keys))
                  stop("'keys' should be a character vector")
              active <- sapply(keys, function(k) {
                  exists(k, env, inherits = FALSE)
              })
              if(any(active)) {
                  warning("keys with active/regular bindings ignored: ",
                          paste(sQuote(keys[active]), collapse = ", "))
                  keys <- keys[!active]
              }                      
              make.f <- function(k) {
                  key <- k
                  function(value) {
                      if(!missing(value)) {
                          dbInsert(db, key, value)
                          invisible(value)
                      }
                      else {
                          obj <- dbFetch(db, key)
                          obj
                      }
                  }
              }
              for(k in keys) 
                  makeActiveBinding(k, make.f(k), env)
              invisible(keys)
          })

#' @param db a filehash database object
#' @param ... arguments passed to other methods
#' 
#' @details \code{dbLazyLoad} loads objects in the database directly into the
#' environment specified, like \code{load} does except with promises. 
#' \code{dbLazyLoad} takes a second argument \code{env}, which is an 
#' environment, and the default for \code{env} is \code{parent.frame()}. 

#' @details  With \code{dbLazyLoad} database objects are "lazy-loaded" into 
#' the environment. Promises to load the objects are created in the environment 
#' specified by \code{env}.  Upon first access, those objects are copied into 
#' the environment and will from then on reside in memory.  Changes to the
#' database will not be reflected in the object residing in the environment 
#' after first access.  Conversely, changes to the object in the environment 
#' will not be reflected in the database.  This type of loading is useful for 
#' read-only databases.
#' 
#' @return dbLoad, dbLazyLoad: a character vector is returned (invisibly) containing the keys associated with the values loaded into the environment.
#' @describeIn dbLoad Lazy load a filehash database
setGeneric("dbLazyLoad", function(db, ...) standardGeneric("dbLazyLoad"))

#' @exportMethod dbLazyLoad
#' @param env environment into which objects should be loaded
#' @param keys specific keys to be loaded (if NULL then all keys are loaded)
#' @describeIn dbLoad Method for filehash databases
setMethod("dbLazyLoad", "filehash",
          function(db, env = parent.frame(2), keys = NULL, ...) {
              if(is.null(keys))
                  keys <- dbList(db)
              else if(!is.character(keys))
                  stop("'keys' should be a character vector")
              
              wrap <- function(x, env) {
                  key <- x
                  delayedAssign(x, dbFetch(db, key), environment(), env)            
              }
              for(k in keys) 
                  wrap(k, env)
              invisible(keys)
          })
          
#' @describeIn dbLoad Load active bindings into an environment and return the environment
#' 
#' @param db filehash database object
#' 
#' @return db2env: environment containing database keys
#' 
#' @details \code{db2env} loads the entire database \code{db} into an 
#' environment via calls to \code{makeActiveBinding}.  Therefore, the data 
#' themselves are not stored in the environment, but a function pointing to 
#' the data in the database is stored.  When an element of the environment is 
#' accessed, the function is called to retrieve the data from the database.  
#' If the data in the database is changed, the changes will be reflected in the 
#' environment. 
#' 
#' 
#' @seealso \code{\link{dbLoad}}, \code{\link{dbLazyLoad}}
#' 
#' @export
db2env <- function(db) {
    if(is.character(db))
        db <- dbInit(db)  ## use the default type
    env <- new.env(hash = TRUE)
    dbLoad(db, env)
    env
}

######################################################################
## Other methods

setGeneric("names")

#' @exportMethod names
#' @param x a filehash object
#' @describeIn filehash Return the keys stored in a filehash database
setMethod("names", "filehash",
          function(x) {
                  dbList(x)
          })

setGeneric("length")

#' @exportMethod length
#' @param x a filehash object
#' @describeIn filehash Return the number of objects in a filehash database
setMethod("length", "filehash",
          function(x) {
                  length(dbList(x))
          })

setGeneric("with")

#' @exportMethod with
#' @param data a filehash object
#' @param expr an R expression to be evaluated
#' @describeIn filehash Use a filehash database as an evaluation environment
setMethod("with", "filehash",
          function(data, expr, ...) {
              env <- db2env(data)
              eval(substitute(expr), env, enclos = parent.frame())
          })

setGeneric("lapply")

#' @exportMethod lapply
#' @param FUN a function to be applied
#' @param X a filehash object
#' @param keep.names Should the key names be returned in the resulting list?
#' @describeIn filehash Apply a function over the elements of a filehash database
setMethod("lapply", signature(X = "filehash"),
          function(X, FUN, ..., keep.names = TRUE) {
              FUN <- match.fun(FUN)
              keys <- dbList(X)
              rval <- vector("list", length = length(keys))
              
              for(i in seq(along = keys)) {
                  obj <- dbFetch(X, keys[i])
                  rval[[i]] <- FUN(obj, ...)
              }
              if(keep.names)
                  names(rval) <- keys
              rval
          })

######################################################################
## Database interface

#' @describeIn filehash Retrieve values associated with multiple keys (a list of those values is returned).
#' @param db a filehash object
#' @param key a character vector indicating a key (or keys) to retreive
setGeneric("dbMultiFetch", function(db, key, ...) {
        standardGeneric("dbMultiFetch")
})

#' @describeIn filehash Insert a key-value pair into the database.  If that key already exists, its associated value is overwritten. For \code{"RDS"} type databases, there is a \code{safe} option (defaults to \code{TRUE}) which allows the user to insert objects somewhat more safely (objects should not be lost in the event of an interrupt).
setGeneric("dbInsert", function(db, key, value, ...) {
        standardGeneric("dbInsert")
})

#' @describeIn filehash Retrieve the value associated with a given key.
setGeneric("dbFetch", function(db, key, ...) standardGeneric("dbFetch"))

#' @describeIn filehash Check to see if a key exists.
setGeneric("dbExists", function(db, key, ...) standardGeneric("dbExists"))

#' @describeIn filehash List all keys in the database.
setGeneric("dbList", function(db, ...) standardGeneric("dbList"))

#' @describeIn filehash The \code{dbDelete} function is for deleting elements, but for the \code{"DB1"} format all it does is remove the key from the lookup table. The actual data are still in the database (but inaccessible).  If you reinsert data for the same key, the new data are simply appended on to the end of the file.  Therefore, it's possible to have multiple copies of data lying around after a while, potentially making the database file big.  The \code{"RDS"} format does not have this problem.
setGeneric("dbDelete", function(db, key, ...) standardGeneric("dbDelete"))

#' @describeIn filehash The \code{dbReorganize} function is there for the purpose of rewriting the database to remove all of the stale entries.  Basically, this function creates a new copy of the database and then overwrites the old copy.  This function has not been tested extensively and so should be considered \emph{experimental}.  \code{dbReorganize} is not needed when using the \code{"RDS"} format.
setGeneric("dbReorganize", function(db, ...) standardGeneric("dbReorganize"))

#' @describeIn filehash Delete an entire database from the disk.
setGeneric("dbUnlink", function(db, ...) standardGeneric("dbUnlink"))

## Other
setOldClass(c("file", "connection"))
setGeneric("lockFile", function(db, ...) standardGeneric("lockFile"))

######################################################################
## Extractor/replacement

#' @exportMethod `[[`
#' @param j not used
#' @describeIn filehash Extract elements of a filehash database using character names
#' @aliases `[[,filehash,character,missing-method`
setMethod("[[", signature(x = "filehash", i = "character", j = "missing"),
          function(x, i, j) {
              dbFetch(x, i)
          })

#' @exportMethod `$`
#' @describeIn filehash Extract elements of a filehash database using character names
setMethod("$", signature(x = "filehash"),
          function(x, name) {
              dbFetch(x, name)
          })

#' @exportMethod `[[<-`
#' @param x a filehash object
#' @param i a character index
#' @param value an R object
#' @describeIn filehash Replace elements of a filehash database
setReplaceMethod("[[", signature(x = "filehash", i = "character", j = "missing"),
                 function(x, i, j, value) {
                     dbInsert(x, i, value)
                     x
                 })

#' @exportMethod `$<-`
#' @param x a filehash object
#' @param name the name of the element in the filehash database
#' @param value an R object
#' @describeIn filehash Replace elements of a filehash database
setReplaceMethod("$", signature(x = "filehash"),
                 function(x, name, value) {
                     dbInsert(x, name, value)
                     x
                 })


## Need to define these because they're not automatically caught.
## Don't need this if R >= 2.4.0.

#' @exportMethod `[`
#' @param drop should dimensions be dropped? (not used)
#' @describeIn filehash Retrieve multiple elements of a filehash database
setMethod("[", signature(x = "filehash", i = "character", j = "missing",
                         drop = "missing"),
          function(x, i , j, drop) {
                  dbMultiFetch(x, i)
          })

######################################################################
## Copyright (C) 2006--2008, Roger D. Peng <rpeng@jhsph.edu>
##     
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.
## 
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
## 
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
## 02110-1301, USA
#####################################################################

dumpEnv <- function(env, dbName) {
        keys <- ls(env, all.names = TRUE)
        dumpObjects(list = keys, dbName = dbName, envir = env)
}

dumpImage <- function(dbName = "Rworkspace", type = NULL) {
        dumpObjects(list = ls(envir = globalenv(), all.names = TRUE),
                    dbName = dbName, type = type, envir = globalenv())
}

dumpObjects <- function(..., list = character(0), dbName, type = NULL,
                        envir = parent.frame()) {
        names <- as.character(substitute(list(...)))[-1]
        list <- c(list, names)
        if(!dbCreate(dbName, type))
                stop("could not create database file")
        db <- dbInit(dbName, type)

        for(i in seq(along = list)) 
                dbInsert(db, list[i], get(list[i], envir))
        db
}

dumpDF <- function(data, dbName = NULL, type = NULL) {
        if(is.null(dbName))
                dbName <- as.character(substitute(data))
        dumpList(as.list(data), dbName = dbName, type = type)
}

dumpList <- function(data, dbName = NULL, type = NULL) {
        if(!is.list(data))
                stop("'data' must be a list")
        vnames <- names(data)
        
        if(is.null(vnames) || isTRUE("" %in% vnames))
                stop("list must have non-empty names")
        if(is.null(dbName))
                dbName <- as.character(substitute(data))
        
        if(!dbCreate(dbName, type))
                stop("could not create database file")
        db <- dbInit(dbName, type)

        for(i in seq(along = vnames))
                dbInsert(db, vnames[i], data[[vnames[i]]])
        db
}

######################################################################
## Copyright (C) 2006--2008, Roger D. Peng <rpeng@jhsph.edu>
##     
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.
## 
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
## 
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
## 02110-1301, USA
#####################################################################

######################################################################
## Class 'filehashDB1'

## Database entries
##
## File format: [key]        [nbytes data] [data]
##              serialized   serialized    raw bytes (serialized)
##

######################################################################

## 'meta' is a list of functions for updating the file size of the
## database and the file map.

setClass("filehashDB1",
         representation(datafile = "character",
                        meta = "list"),
         contains = "filehash"
         )

setValidity("filehashDB1",
            function(object) {
                    if(!file.exists(object@datafile))
                            return(gettextf("datafile '%s' does not exist",
                                            datafile))
                    TRUE
            })

createDB1 <- function(dbName) {
        if(!hasWorkingFtell())
                stop("need working 'ftell()' to use 'DB1' format")
        if(file.exists(dbName)) {
                message(gettextf("database '%s' already exists", dbName))
                return(TRUE)
        }
        status <- file.create(dbName)

        if(!status)
                stop(gettextf("unable to create database file '%s'", dbName))
        TRUE
}

makeMetaEnv <- function(filename) {
        dbmap <- NULL  ## 'NULL' indicates the map needs to be read
        dbfilesize <- file.info(filename)$size

        updatesize <- function(size) {
                dbfilesize <<- size
        }
        updatemap <- function(map) {
                dbmap <<- map
        }
        getsize <- function() {
                dbfilesize
        }
        getmap <- function() {
                dbmap
        }
        list(updatesize = updatesize,
             updatemap = updatemap,
             getmap = getmap,
             getsize = getsize)
}

initializeDB1 <- function(dbName) {
        if(!hasWorkingFtell())
                stop("need working 'ftell()' to use DB1 format")
        dbName <- normalizePath(dbName)

        new("filehashDB1",
            datafile = dbName,
            meta = makeMetaEnv(dbName),
            name = basename(dbName)
            )
}


readKeyMap <- function(con, map = NULL, pos = 0) {
        if(is.null(map)) {
                ## using 'hash = TRUE' is critical because it can have a major
                ## impact on performance for large databases
                map <- new.env(hash = TRUE, parent = emptyenv())
                pos <- 0
        }
        if(pos < 0)
                stop("'pos' cannot be negative")
        filename <- path.expand(summary(con)$description)
        filesize <- file.info(filename)$size

        if(pos > filesize)
                stop("'pos' cannot be greater than file size")
        .Call(C_read_key_map, filename, map, filesize, pos)
}

readSingleKey <- function(con, map, key) {
        start <- map[[key]]

        if(is.null(start))
                stop(gettextf("unable to obtain value for key '%s'", key))

        seek(con, start, rw = "read")
        unserialize(con)
}

readKeys <- function(con, map, keys) {
        r <- lapply(keys, function(key) readSingleKey(con, map, key))
        names(r) <- keys
        r
}

gotoEndPos <- function(con) {
        ## Move connection to the end
        seek(con, 0, "end")
        seek(con)
}

writeNullKeyValue <- function(con, key) {
        writestart <- gotoEndPos(con)

        handler <- function(cond) {
                ## Rewind the file back to where writing began and truncate at
                ## that position
                seek(con, writestart, "start", "write")
                truncate(con)
                cond
        }
        tryCatch({
                serialize(key, con)

                len <- as.integer(-1)
                serialize(len, con)
        }, interrupt = handler, error = handler, finally = {
                flush(con)
        })
}

writeKeyValue <- function(con, key, value) {
        writestart <- gotoEndPos(con)

        handler <- function(cond) {
                ## Rewind the file back to where writing began and
                ## truncate at that position; this is probably a bad
                ## idea for files > 2GB
                seek(con, writestart, "start", "write")
                truncate(con)
                cond
        }
        tryCatch({
                serialize(key, con)

                byteData <- serialize(value, NULL)
                len <- length(byteData)
                serialize(len, con)

                writeBin(byteData, con)
        }, interrupt = handler, error = handler, finally = {
                flush(con)
        })
}

setMethod("lockFile", "file", function(db, ...) {
        ## Use 3 underscores for lock file
        sprintf("%s___LOCK", summary(db)$description)
})

createLockFile <- function(name) {
        if(.Platform$OS.type != "windows") 
                status <- .Call(C_lock_file, name)
        else {
                ## TODO: are these optimal values for max.attempts
                ## and sleep.duration?
                max.attempts <- 4
                sleep.duration <- 0.5
                attempts <- 0
                status <- -1
                while ((attempts <= max.attempts) && ! isTRUE(status >= 0)) {
                        attempts <- attempts + 1
                        status <- .Call(C_lock_file, name)

                        if(!isTRUE(status >= 0))
                                Sys.sleep(sleep.duration)
                }
        }
        if(!isTRUE(status >= 0))
                stop("cannot create lock file ", sQuote(name))
        TRUE
}

deleteLockFile <- function(name) {
        if(!file.remove(name))
                stop(paste('cannot remove lock file "', name, '"', sep=''))
        TRUE
}

################################################################################
## Internal utilities

filesize <- gotoEndPos

setGeneric("checkMap", function(db, ...) standardGeneric("checkMap"))

setMethod("checkMap", "filehashDB1",
          function(db, filecon, ...) {
                  old.size <- db@meta$getsize()
                  cur.size <- tryCatch({
                          filesize(filecon)
                  }, error = function(err) {
                          old.size
                  })
                  size.change <- old.size != cur.size
                  map <- getMap(db)
                  map0 <- map

                  if(is.null(map))
                          map <- readKeyMap(filecon)
                  else if(size.change) {
                          ## Modify 'map.old' directly
                          map <- tryCatch({
                                  readKeyMap(filecon, map, old.size)
                          }, error = function(err) {
                                  message(conditionMessage(err))
                                  map0
                          })
                  }
                  else
                          map <- map0
                  if(!identical(map, map0)) {
                          db@meta$updatemap(map)
                          db@meta$updatesize(cur.size)
                  }
                  invisible(db)
          })


setGeneric("getMap", function(db) standardGeneric("getMap"))

setMethod("getMap", "filehashDB1",
          function(db) {
                  db@meta$getmap()
          })

################################################################################
## Interface functions

openDBConn <- function(filename, mode) {
        con <- try({
                file(filename, mode)
        }, silent = TRUE)

        if(inherits(con, "try-error"))
                stop("unable to open connection to database")
        con
}

setMethod("dbInsert",
          signature(db = "filehashDB1", key = "character", value = "ANY"),
          function(db, key, value, ...) {
                  con <- openDBConn(db@datafile, "ab")
                  on.exit(close(con))

                  lockname <- lockFile(con)
                  createLockFile(lockname)
                  on.exit(deleteLockFile(lockname), add = TRUE)

                  invisible(writeKeyValue(con, key, value))
          })

setMethod("dbFetch",
          signature(db = "filehashDB1", key = "character"),
          function(db, key, ...) {
                  con <- openDBConn(db@datafile, "rb")
                  on.exit(close(con))

                  lockname <- lockFile(con)
                  createLockFile(lockname)
                  on.exit(deleteLockFile(lockname), add = TRUE)

                  checkMap(db, con)
                  map <- getMap(db)

                  val <- readSingleKey(con, map, key)
                  val
          })

setMethod("dbMultiFetch",
          signature(db = "filehashDB1", key = "character"),
          function(db, key, ...) {
                  con <- openDBConn(db@datafile, "rb")
                  on.exit(close(con))

                  lockname <- lockFile(con)
                  createLockFile(lockname)
                  on.exit(deleteLockFile(lockname), add = TRUE)

                  checkMap(db, con)
                  map <- getMap(db)

                  readKeys(con, map, key)
          })

setMethod("dbExists", signature(db = "filehashDB1", key = "character"),
          function(db, key, ...) {
                  dbkeys <- dbList(db)
                  key %in% dbkeys
          })

setMethod("dbList", "filehashDB1",
          function(db, ...) {
                  con <- openDBConn(db@datafile, "rb")
                  on.exit(close(con))

                  lockname <- lockFile(con)
                  createLockFile(lockname)
                  on.exit(deleteLockFile(lockname), add = TRUE)

                  checkMap(db, con)
                  map <- getMap(db)

                  if(length(map) == 0)
                          character(0)
                  else {
                          keys <- as.list(map, all.names = TRUE)
                          use <- !sapply(keys, is.null)
                          names(keys[use])
                  }
          })

setMethod("dbDelete", signature(db = "filehashDB1", key = "character"),
          function(db, key, ...) {
                  con <- openDBConn(db@datafile, "ab")
                  on.exit(close(con))

                  lockname <- lockFile(con)
                  createLockFile(lockname)
                  on.exit(deleteLockFile(lockname), add = TRUE)

                  invisible(writeNullKeyValue(con, key))
          })

setMethod("dbUnlink", "filehashDB1",
          function(db, ...) {
                  file.remove(db@datafile)
          })

reorganizeDB <- function(db, ...) {
        datafile <- db@datafile

        ## Find a temporary file name
        tempdata <- paste(datafile, "Tmp", sep = "")
        i <- 0
        while(file.exists(tempdata)) {
                i <- i + 1
                tempdata <- paste(datafile, "Tmp", i, sep = "")
        }
        if(!dbCreate(tempdata, type = "DB1")) {
                warning("could not create temporary database")
                return(FALSE)
        }
        on.exit(file.remove(tempdata))

        tempdb <- dbInit(tempdata, type = "DB1")
        keys <- dbList(db)

        ## Copy all keys to temporary database
        nkeys <- length(keys)
        cat("Reorganizing database: ")

        for(i in seq_along(keys)) {
                key <- keys[i]
                msg <- sprintf("%d%% (%d/%d)", round (100 * i / nkeys),
                               i, nkeys)
                cat(msg)

                dbInsert(tempdb, key, dbFetch(db, key))

                back <- paste(rep("\b", nchar(msg)), collapse = "")
                cat(back)
        }
        cat("\n")
        status <- file.rename(tempdata, datafile)

        if(!isTRUE(status)) {
                on.exit()
                warning("temporary database could not be renamed and is left in ",
                        tempdata)
                return(FALSE)
        }
        on.exit()
        cat("Finished; reload database with 'dbInit'\n")
        TRUE
}

setMethod("dbReorganize", "filehashDB1", reorganizeDB)


################################################################################
## Test system's ftell()

hasWorkingFtell <- function() {
        tfile <- tempfile()
        con <- file(tfile, "wb")

        tryCatch({
                bytes <- raw(10)
                begin <- seek(con)

                if(begin != 0)
                        return(FALSE)
                writeBin(bytes, con)
                end <- seek(con)
                offset <- end - begin
                isTRUE(offset == 10)
        }, error = function(e) {
                FALSE
        }, finally = {
                close(con)
                unlink(tfile)
        })
}

######################################################################

######################################################################
## Copyright (C) 2006, Roger D. Peng <rpeng@jhsph.edu>
##     
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.
## 
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
## 
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
## 02110-1301, USA
#####################################################################

toDBType <- function(from, type, dbpath = NULL) {
    if(is.null(dbpath))
        dbpath <- dbName(from)
    if(!dbCreate(dbpath, type = type))
        stop("could not create ", type, " database")
    db <- dbInit(dbpath, type = type)
    keys <- dbList(from)
    
    for(key in keys)
        dbInsert(db, key, dbFetch(from, key))
    invisible(db)
}

setAs("filehashDB1", "filehashRDS",
      function(from) {
          dbpath <- paste(dbName(from), "RDS", sep = "")
          toDBType(from, "RDS", dbpath)
      })
      
setAs("filehashDB1", "list",
      function(from) {
          keys <- dbList(from)
          dbMultiFetch(from, keys)
      })

\name{stackqueue}
\alias{stackqueue}
\alias{push}
\alias{pop}
\alias{mpush}
\alias{top}
\alias{isEmpty}

%- Also NEED an '\alias' for EACH other topic documented here.
\title{Operations on Stacks/Queues}
\description{
  Functions for interacting with stack and queue data structures
  implemented using \code{filehash} databases.
}
\usage{
push(db, val, ...)
mpush(db, vals, ...)
pop(db, ...)
top(db, ...)
isEmpty(db, ...)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{db}{an object of class \code{"stack"} or \code{"queue"}}
  \item{val}{an R object}
  \item{vals}{a list of R objects}
  \item{\dots}{arguments passed to other methods}
}
\details{
  Note that for \code{mpush}, if \code{vals} is not a list it will be
  coerced to a list via \code{as.list}.  Currently, \code{mpush} is only
  implemented for \code{"stack"}s.
}
\value{
  \code{push} and \code{mpush} return nothing useful; \code{pop} returns
  a value from the stack/queue and deletes that value from the
  stack/queue; \code{top} returns the "top" value from the stack/queue;
  \code{isEmpty} returns \code{TRUE}/\code{FALSE} depending on whether
  the stack/queue is empty or not.  Both \code{pop} and \code{top}
  signal an error if the stack/queue is empty.
}
\author{Roger D. Peng \email{rpeng@jhsph.edu}}
\keyword{database}% __ONLY ONE__ keyword per line

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/filehash.R
\name{dbLoad}
\alias{dbLoad}
\alias{dbLoad,filehash-method}
\alias{dbLazyLoad}
\alias{dbLazyLoad,filehash-method}
\alias{db2env}
\title{Load a Database}
\usage{
dbLoad(db, ...)

\S4method{dbLoad}{filehash}(db, env = parent.frame(2), keys = NULL, ...)

dbLazyLoad(db, ...)

\S4method{dbLazyLoad}{filehash}(db, env = parent.frame(2), keys = NULL, ...)

db2env(db)
}
\arguments{
\item{db}{filehash database object}

\item{...}{arguments passed to other methods}

\item{env}{environment into which objects should be loaded}

\item{keys}{specific keys to be loaded (if NULL then all keys are loaded)}
}
\value{
dbLoad, dbLazyLoad: a character vector is returned (invisibly) containing the keys associated with the values loaded into the environment.

db2env: environment containing database keys
}
\description{
Load entire database into an environment
}
\details{
\code{dbLoad} loads objects in the database directly into the 
environment specified, like \code{load} does except with active bindings. 
\code{dbLoad} takes a second argument \code{env}, which is an 
environment, and the default for \code{env} is \code{parent.frame()}.

The use of \code{makeActiveBinding} in \code{db2env} and 
\code{dbLoad} allows for potentially large databases to, at least 
conceptually, be used in R, as long as you don't need simultaneous access to 
all of the elements in the database.

\code{dbLazyLoad} loads objects in the database directly into the
environment specified, like \code{load} does except with promises. 
\code{dbLazyLoad} takes a second argument \code{env}, which is an 
environment, and the default for \code{env} is \code{parent.frame()}.

With \code{dbLazyLoad} database objects are "lazy-loaded" into 
the environment. Promises to load the objects are created in the environment 
specified by \code{env}.  Upon first access, those objects are copied into 
the environment and will from then on reside in memory.  Changes to the
database will not be reflected in the object residing in the environment 
after first access.  Conversely, changes to the object in the environment 
will not be reflected in the database.  This type of loading is useful for 
read-only databases.

\code{db2env} loads the entire database \code{db} into an 
environment via calls to \code{makeActiveBinding}.  Therefore, the data 
themselves are not stored in the environment, but a function pointing to 
the data in the database is stored.  When an element of the environment is 
accessed, the function is called to retrieve the data from the database.  
If the data in the database is changed, the changes will be reflected in the 
environment.
}
\section{Methods (by class)}{
\itemize{
\item \code{dbLoad(filehash)}: Method for filehash databases

\item \code{dbLazyLoad(filehash)}: Method for filehash databases

}}
\section{Functions}{
\itemize{
\item \code{dbLazyLoad()}: Lazy load a filehash database

\item \code{db2env()}: Load active bindings into an environment and return the environment

}}
\seealso{
\code{\link{dbLoad}}, \code{\link{dbLazyLoad}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/queue.R
\docType{class}
\name{queue-class}
\alias{queue-class}
\alias{createQ}
\alias{initQ}
\alias{pop}
\alias{push}
\alias{isEmpty}
\alias{top}
\alias{show,queue-method}
\alias{push,queue-method}
\alias{isEmpty,queue-method}
\alias{top,queue-method}
\alias{pop,queue-method}
\title{A Queue Class}
\usage{
createQ(filename)

initQ(filename)

pop(db, ...)

push(db, val, ...)

isEmpty(db, ...)

top(db, ...)

\S4method{show}{queue}(object)

\S4method{push}{queue}(db, val, ...)

\S4method{isEmpty}{queue}(db)

\S4method{top}{queue}(db, ...)

\S4method{pop}{queue}(db, ...)
}
\arguments{
\item{filename}{name of queue file}

\item{db}{a queue object}

\item{...}{arguments passed to other methods}

\item{val}{an R object to be added to the tail queue}

\item{object}{a queue object}
}
\value{
\code{createQ} and \code{initQ} return a \code{queue} object
}
\description{
A queue implementation using a \code{filehash} database
}
\details{
Objects can be created by calls of the form \code{new("queue", ...)} or by calling \code{createQ}.  Existing queues can be initialized with \code{initQ}.
}
\section{Methods (by generic)}{
\itemize{
\item \code{show(queue)}: Print a queue object

\item \code{push(queue)}: adds an element to the tail ("bottom") of the queue

\item \code{isEmpty(queue)}: returns \code{TRUE}/\code{FALSE} depending on whether there are elements in the queue.

\item \code{top(queue)}: returns the value of the "top" (i.e. head) of the queue; an error is signaled if the queue is empty

\item \code{pop(queue)}: returns the value of the "top" (i.e. head) of the queue and subsequently removes that element from the queue; an error is signaled if the queue is empty

}}
\section{Functions}{
\itemize{
\item \code{createQ()}: Create a file-based queue object

\item \code{initQ()}: Intialize an existing queue object

\item \code{pop()}: Return (and remove) the top element of a queue

\item \code{push()}: Push an R object on to the tail of a queue

\item \code{isEmpty()}: Check if a queue is empty or not

\item \code{top()}: Return the top of the queue

}}
\section{Slots}{

\describe{
\item{\code{queue}}{Object of class \code{"filehashDB1"}}

\item{\code{name}}{Object of class \code{"character"}: the name of the queue (default is the file name in which the queue data are stored)}
}}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/filehash-DB1.R
\docType{class}
\name{filehashDB1-class}
\alias{filehashDB1-class}
\alias{dbInsert,filehashDB1,character-method}
\alias{dbFetch,filehashDB1,character-method}
\alias{dbMultiFetch,filehashDB1,character-method}
\alias{dbExists,filehashDB1,character-method}
\alias{dbList,filehashDB1-method}
\alias{dbDelete,filehashDB1,character-method}
\alias{dbUnlink,filehashDB1-method}
\alias{dbReorganize,filehashDB1-method}
\title{Filehash DB1 Class}
\usage{
\S4method{dbInsert}{filehashDB1,character}(db, key, value, ...)

\S4method{dbFetch}{filehashDB1,character}(db, key, ...)

\S4method{dbMultiFetch}{filehashDB1,character}(db, key, ...)

\S4method{dbExists}{filehashDB1,character}(db, key, ...)

\S4method{dbList}{filehashDB1}(db, ...)

\S4method{dbDelete}{filehashDB1,character}(db, key, ...)

\S4method{dbUnlink}{filehashDB1}(db, ...)

\S4method{dbReorganize}{filehashDB1}(db, ...)
}
\arguments{
\item{db}{a filehashDB1 object}

\item{key}{character, the name of an R object in the database}

\item{value}{an R object}

\item{...}{arguments passed to other methods}
}
\description{
An implementation of filehash databases using a single large file
}
\details{
For \code{dbMultiFetch}, \code{key} is a character vector of keys.
}
\section{Methods (by generic)}{
\itemize{
\item \code{dbInsert(db = filehashDB1, key = character)}: Insert an R object into a filehashDB1 database

\item \code{dbFetch(db = filehashDB1, key = character)}: Retrieve an object from a filehash DB1 database

\item \code{dbMultiFetch(db = filehashDB1, key = character)}: Retrieve multiple objects from a filehash DB1 database

\item \code{dbExists(db = filehashDB1, key = character)}: Determine if a key exists in a filehash DB1 database

\item \code{dbList(filehashDB1)}: Return a character vector containing all keys in a database

\item \code{dbDelete(db = filehashDB1, key = character)}: Delete a key and it's corresponding object from a filehashDB1 database

\item \code{dbUnlink(filehashDB1)}: Delete an entire filehashDB1 database

\item \code{dbReorganize(filehashDB1)}: Reorganize and compactify a filehahsDB1 database

}}
\section{Slots}{

\describe{
\item{\code{datafile}}{full path to the database file (filehashDB1 only)}

\item{\code{meta}}{list containing an environment for database metadata (filehashDB1 only)}
}}

\name{dbLoad}
\alias{dbLoad}
\alias{dbLoad,filehash-method}
\alias{dbLazyLoad}
\alias{dbLazyLoad,filehash-method}
\alias{db2env}

\title{Load database into environment}
\description{
  Load entire database into an environment
}
\usage{
db2env(db)
dbLoad(db, ...)
dbLazyLoad(db, ...)

\S4method{dbLoad}{filehash}(db, env = parent.frame(2), keys = NULL, ...)
\S4method{dbLazyLoad}{filehash}(db, env = parent.frame(2), keys = NULL, ...)
}
\arguments{
  \item{db}{database object}
  \item{env}{an environment}
  \item{keys}{character vector of database keys to load}
  \item{...}{other arguments passed to methods}
}
\details{
  \code{db2env} loads the entire database \code{db} into an environment
  via calls to \code{makeActiveBinding}.  Therefore, the data themselves
  are not stored in the environment, but a function pointing to the data
  in the database is stored.  When an element of the environment is
  accessed, the function is called to retrieve the data from the
  database.  If the data in the database is changed, the changes will be
  reflected in the environment.

  \code{dbLoad} loads objects in the database directly into the
  environment specified, like \code{load} does except with active bindings.
  \code{dbLoad} takes a second argument \code{env}, which is an
  environment, and the default for \code{env} is \code{parent.frame()}. 

  The use of \code{makeActiveBinding} in \code{db2env} and \code{dbLoad}
  allows for potentially large databases to, at least conceptually, be
  used in R, as long as you don't need simultaneous access to all of the
  elements in the database.

  With \code{dbLazyLoad} database objects are
  "lazy-loaded" into the environment.  Promises to load the
  objects are created in the environment specified by \code{env}.  Upon
  first access, those objects are copied into the environment and will
  from then on reside in memory.  Changes to the database will not be
  reflected in the object residing in the environment after first
  access.  Conversely, changes to the object in the environment will not
  be reflected in the database.  This type of loading is useful for
  read-only databases.
}

\value{
  For \code{db2env}, an environment is returned, the elements of which
  are the keys of the database.  For \code{dbLoad} and \code{dbLazyLoad}, a character vector
  is returned (invisibly) containing the keys associated with the values
  loaded into the environment.
}

\author{Roger D. Peng}

\seealso{
  \code{\link{dbInit}} and \code{\link{filehash-class}}
}

\examples{
dbCreate("myDB")
db <- dbInit("myDB")
dbInsert(db, "a", rnorm(100))
dbInsert(db, "b", 1:10)

env <- db2env(db)
ls(env)  ## "a", "b"
print(env$b)
mean(env$a)
env$a <- rnorm(100)
mean(env$a)

env$b[1:5] <- 5:1
print(env$b)

env <- new.env()
dbLoad(db, env)
ls(env)

env <- new.env()
dbLazyLoad(db, env)
ls(env)

as(db, "list")
}

\keyword{database}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/filehash-RDS.R
\docType{class}
\name{filehashRDS-class}
\alias{filehashRDS-class}
\alias{dbInsert,filehashRDS,character-method}
\alias{dbFetch,filehashRDS,character-method}
\alias{dbMultiFetch,filehashRDS,character-method}
\alias{dbExists,filehashRDS,character-method}
\alias{dbList,filehashRDS-method}
\alias{dbDelete,filehashRDS,character-method}
\alias{dbUnlink,filehashRDS-method}
\title{Filehash RDS Class}
\usage{
\S4method{dbInsert}{filehashRDS,character}(db, key, value, safe = TRUE, ...)

\S4method{dbFetch}{filehashRDS,character}(db, key, ...)

\S4method{dbMultiFetch}{filehashRDS,character}(db, key, ...)

\S4method{dbExists}{filehashRDS,character}(db, key, ...)

\S4method{dbList}{filehashRDS}(db, ...)

\S4method{dbDelete}{filehashRDS,character}(db, key, ...)

\S4method{dbUnlink}{filehashRDS}(db, ...)
}
\arguments{
\item{db}{a filehashRDS object}

\item{key}{character, the name of an R object}

\item{value}{an R object}

\item{safe}{Should the operation be done safely?}

\item{...}{arguments passed to other methods}
}
\description{
An implementation of filehash databases using diretories and separate files
}
\details{
When \code{safe = TRUE} in \code{dbInsert}, objects are written to a temp file before replacing any existing objects. This way, if the operation is interrupted, the original data are not corrupted.

For \code{dbMultiFetch}, \code{key} is a character vector of keys.
}
\section{Methods (by generic)}{
\itemize{
\item \code{dbInsert(db = filehashRDS, key = character)}: Insert an R object into a filehashRDS database

\item \code{dbFetch(db = filehashRDS, key = character)}: Retrieve a value from a filehashRDS database

\item \code{dbMultiFetch(db = filehashRDS, key = character)}: Retrieve multiple objects from a filehashRDS database

\item \code{dbExists(db = filehashRDS, key = character)}: Determine if a key exists in a filehashRDS database

\item \code{dbList(filehashRDS)}: Return a character vector of all key stored in a database

\item \code{dbDelete(db = filehashRDS, key = character)}: Delete a key and its corresponding object from a filehashRDS database

\item \code{dbUnlink(filehashRDS)}: Delete an entire filehashRDS database

}}
\section{Slots}{

\describe{
\item{\code{dir}}{Directory where files are stored (filehashRDS only)}
}}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/filehash.R
\docType{class}
\name{filehash-class}
\alias{filehash-class}
\alias{show,filehash-method}
\alias{dbCreate,ANY-method}
\alias{dbCreate}
\alias{dbInit,ANY-method}
\alias{dbInit}
\alias{names,filehash-method}
\alias{length,filehash-method}
\alias{with,filehash-method}
\alias{lapply,filehash-method}
\alias{dbMultiFetch}
\alias{dbInsert}
\alias{dbFetch}
\alias{dbExists}
\alias{dbList}
\alias{dbDelete}
\alias{dbReorganize}
\alias{dbUnlink}
\alias{[[,filehash,character,missing-method}
\alias{`[[,filehash,character,missing-method`}
\alias{$,filehash-method}
\alias{[[<-,filehash,character,missing-method}
\alias{$<-,filehash-method}
\alias{[,filehash,character,missing,missing-method}
\title{Filehash Class}
\usage{
\S4method{show}{filehash}(object)

\S4method{dbCreate}{ANY}(db, type = NULL, ...)

\S4method{dbInit}{ANY}(db, type = NULL, ...)

\S4method{names}{filehash}(x)

\S4method{length}{filehash}(x)

\S4method{with}{filehash}(data, expr, ...)

\S4method{lapply}{filehash}(X, FUN, ..., keep.names = TRUE)

dbMultiFetch(db, key, ...)

dbInsert(db, key, value, ...)

dbFetch(db, key, ...)

dbExists(db, key, ...)

dbList(db, ...)

dbDelete(db, key, ...)

dbReorganize(db, ...)

dbUnlink(db, ...)

\S4method{[[}{filehash,character,missing}(x, i, j)

\S4method{$}{filehash}(x, name)

\S4method{[[}{filehash,character,missing}(x, i, j) <- value

\S4method{$}{filehash}(x, name) <- value

\S4method{[}{filehash,character,missing,missing}(x, i, j, drop)
}
\arguments{
\item{object}{a filehash object}

\item{db}{a filehash object}

\item{type}{filehash database type}

\item{...}{arguments passed to other methods}

\item{x}{a filehash object}

\item{data}{a filehash object}

\item{expr}{an R expression to be evaluated}

\item{X}{a filehash object}

\item{FUN}{a function to be applied}

\item{keep.names}{Should the key names be returned in the resulting list?}

\item{key}{a character vector indicating a key (or keys) to retreive}

\item{value}{an R object}

\item{i}{a character index}

\item{j}{not used}

\item{name}{the name of the element in the filehash database}

\item{drop}{should dimensions be dropped? (not used)}
}
\description{
These functions form the interface for a simple file-based key-value database (i.e. hash table).
}
\details{
Objects can be created by calls of the form \code{new("filehash", ...)}.
}
\section{Methods (by generic)}{
\itemize{
\item \code{show(filehash)}: Print a filehash object

\item \code{dbCreate(ANY)}: Create a filehash database

\item \code{dbInit(ANY)}: Initialize an existing filehash database

\item \code{names(filehash)}: Return the keys stored in a filehash database

\item \code{length(filehash)}: Return the number of objects in a filehash database

\item \code{with(filehash)}: Use a filehash database as an evaluation environment

\item \code{lapply(filehash)}: Apply a function over the elements of a filehash database

\item \code{x[[i}: Extract elements of a filehash database using character names

\item \code{$}: Extract elements of a filehash database using character names

\item \code{`[[`(x = filehash, i = character, j = missing) <- value}: Replace elements of a filehash database

\item \code{`$`(filehash) <- value}: Replace elements of a filehash database

\item \code{x[i}: Retrieve multiple elements of a filehash database

}}
\section{Functions}{
\itemize{
\item \code{dbMultiFetch()}: Retrieve values associated with multiple keys (a list of those values is returned).

\item \code{dbInsert()}: Insert a key-value pair into the database.  If that key already exists, its associated value is overwritten. For \code{"RDS"} type databases, there is a \code{safe} option (defaults to \code{TRUE}) which allows the user to insert objects somewhat more safely (objects should not be lost in the event of an interrupt).

\item \code{dbFetch()}: Retrieve the value associated with a given key.

\item \code{dbExists()}: Check to see if a key exists.

\item \code{dbList()}: List all keys in the database.

\item \code{dbDelete()}: The \code{dbDelete} function is for deleting elements, but for the \code{"DB1"} format all it does is remove the key from the lookup table. The actual data are still in the database (but inaccessible).  If you reinsert data for the same key, the new data are simply appended on to the end of the file.  Therefore, it's possible to have multiple copies of data lying around after a while, potentially making the database file big.  The \code{"RDS"} format does not have this problem.

\item \code{dbReorganize()}: The \code{dbReorganize} function is there for the purpose of rewriting the database to remove all of the stale entries.  Basically, this function creates a new copy of the database and then overwrites the old copy.  This function has not been tested extensively and so should be considered \emph{experimental}.  \code{dbReorganize} is not needed when using the \code{"RDS"} format.

\item \code{dbUnlink()}: Delete an entire database from the disk.

}}
\section{Slots}{

\describe{
\item{\code{name}}{Object of class \code{"character"}, name of the database.}
}}

\name{createQ}
\alias{createQ}
\alias{initQ}

%- Also NEED an '\alias' for EACH other topic documented here.
\title{Create/Initialize Queue}
\description{
  Create or initialize a queue data structure using \code{filehash}
  databases
}
\usage{
createQ(filename)
initQ(filename)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{filename}{character, file name for storing the queue data
    structure}
}
\details{
  A new queue can be created using \code{createQ}, which creates a file
  for storing the queue information and returns an object of class
  \code{"queue"}.
}
\value{
  The \code{createQ} and \code{initQ} functions both return an object of
  class \code{"queue"}.
}
\author{Roger D. Peng \email{rpeng@jhsph.edu}}

\keyword{database}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/stack.R
\docType{class}
\name{stack-class}
\alias{stack-class}
\alias{show,stack-method}
\alias{createS}
\alias{initS}
\alias{push,stack-method}
\alias{mpush}
\alias{mpush,stack-method}
\alias{isEmpty,stack-method}
\alias{top,stack-method}
\alias{pop,stack-method}
\title{Stack Class}
\usage{
\S4method{show}{stack}(object)

createS(filename)

initS(filename)

\S4method{push}{stack}(db, val, ...)

mpush(db, vals, ...)

\S4method{mpush}{stack}(db, vals, ...)

\S4method{isEmpty}{stack}(db, ...)

\S4method{top}{stack}(db, ...)

\S4method{pop}{stack}(db, ...)
}
\arguments{
\item{object}{a stack object}

\item{filename}{name of file where stack is stored}

\item{db}{a stack object}

\item{val}{an R object to be added to the stack}

\item{...}{arguments passed to other methods}

\item{vals}{a list of R objects}
}
\value{
a stack object
}
\description{
A stack implementation using a \code{filehash} database
}
\details{
Objects can be created by calls of the form \code{new("stack", ...)} or by calling \code{createS}.  Existing queues can be initialized with \code{initS}.
}
\section{Methods (by generic)}{
\itemize{
\item \code{show(stack)}: Print a stack object.

\item \code{push(stack)}: Push an object on to the stack

\item \code{mpush(stack)}: Push a list of R objects on to the stack

\item \code{isEmpty(stack)}: Indicate whether the stack is empty or not

\item \code{top(stack)}: Return the top element of the stack

\item \code{pop(stack)}: Return the top element of the stack and remove that element from the stack

}}
\section{Functions}{
\itemize{
\item \code{createS()}: Create a filehash Stack

\item \code{initS()}: Initialize and existing filehash stack

\item \code{mpush()}: Push multiple R objects on to a stack

}}
\section{Slots}{

\describe{
\item{\code{stack}}{Object of class \code{"filehashDB1"}}

\item{\code{name}}{Object of class \code{"character"}: the name of the stack (default is the file name in which the stack data are stored)}
}}

\name{dbInit}
\alias{dbInit}
\alias{dbInitialize}
\alias{dbCreate}
\alias{dbCreate,ANY-method}
\alias{dbInit,ANY-method}

%\alias{dbInitialize}

\title{Simple file-based hash table}
\description{
  Interface for creating and initializing a simple file-based hash table
}
\usage{
dbCreate(db, ...)
dbInit(db, ...)

\S4method{dbCreate}{ANY}(db, type = NULL, ...)
\S4method{dbInit}{ANY}(db, type = NULL, ...)
}

\arguments{
  \item{db}{name of database or a database object}
  \item{type}{type of database format.  If missing, the default type
    will be used}
  \item{...}{other arguments passed to methods}
}

\details{
  \code{dbCreate} creates the necessary files or directory for the
  database.  If those files already exist nothing is done.

  \code{dbInit} takes a database name and returns an object
  inheriting from class \code{"filehash"}.

  The \code{type} argument specifies the format in which the database
  should be stored on the disk.  If not specified, the default
  type will be used (as specified by \code{filehashOption}).  
}

\note{
  The function \code{dbInitialize} has been deprecated.  Use
  \code{dbInit} instead.
}

\value{
  \code{dbCreate} returns \code{TRUE} upon success and \code{FALSE} in
  the event of an error.  \code{dbInit} returns an object
  inheriting from class \code{"filehash"}
}

\author{Roger D. Peng}

\seealso{
  See \code{\link{filehash-class}} more information and examples and
  \code{\link{filehashOption}} for setting the default database type.
}

\keyword{database}% at least one, from doc/KEYWORDS

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/filehash.R
\name{filehashOption}
\alias{filehashOption}
\title{Set Filehash Options}
\usage{
filehashOption(...)
}
\arguments{
\item{\dots}{name-value pairs for options}
}
\value{
\code{filehashOptions} returns a list of current settings for all options.
}
\description{
Set global filehash options
}
\details{
Currently, the only option that can be set is the default database type (\code{defaultType}) which can be "DB1", "RDS" or "DB".
}

\name{dumpObjects}
\alias{dumpObjects}
\alias{dumpImage}
\alias{dumpDF}
\alias{dumpList}
\alias{dumpEnv}

\title{Dump objects of database}
\description{
  Dump R objects to a filehash database
}
\usage{
dumpObjects(..., list = character(0), dbName, type = NULL, envir = parent.frame())
dumpImage(dbName = "Rworkspace", type = NULL)
dumpDF(data, dbName = NULL, type = NULL)
dumpList(data, dbName = NULL, type = NULL)
dumpEnv(env, dbName)
}

\arguments{
  \item{\dots}{R objects to dump}
  \item{list}{character vector of names of objects to dump}
  \item{dbName}{character, name of database to which objects should be
    dumped}
  \item{type}{type of database to create}
  \item{envir}{environment from which to obtain objects}
  \item{data}{a data frame or a list}
  \item{env}{an environment}
}
\details{
  Objects dumped to a database can later be loaded via \code{dbLoad} or
  can be accessed with \code{dbFetch}, \code{dbList}, etc.
  Alternatively, the \code{with} method can be used to evaluate code in
  the context of a database.  If a database with name \code{dbName}
  already exists, objects will be inserted into the existing database
  (and values for already-existing keys will be overwritten).

  \code{dumpDF} is different in that each variable in the data frame is
  stored as a separate object in the database.  So each variable can be
  read from the database separately rather than having to load the
  entire data frame into memory.  \code{dumpList} works in a simlar
  way.

  The \code{dumpEnv} function takes an environment and stores each
  element of the environment in a \code{filehash} database.
}

\value{
  An object of class \code{"filehash"} is returned and a database is
  created.
}

\author{Roger D. Peng}

\examples{
data <- data.frame(y = rnorm(100), x = rnorm(100), z = rnorm(100))
db <- dumpDF(data, dbName = "dataframe.dump")
fit <- with(db, lm(y ~ x + z))
summary(fit)

db <- dumpList(list(a = 1, b = 2, c = 3), "list.dump")
db$a
}
\keyword{database}% at least one, from doc/KEYWORDS

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/filehash.R
\name{filehashFormats}
\alias{filehashFormats}
\title{List and register filehash formats}
\usage{
filehashFormats(...)
}
\arguments{
\item{\dots}{list of functions for registering a new database format}
}
\value{
A list containing information on the available filehash formats
}
\description{
List and register filehash backend database formats.
}
\details{
\code{filehashFormats} can be used to register new filehash backend database formats.  \code{filehashFormats} called with no arguments lists information on available formats
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/coerce.R
\name{coercelist}
\alias{coercelist}
\alias{coerce,filehash,list-method}
\title{Coerce a filehash database}
\arguments{
\item{from}{a filehash database object}
}
\description{
Coerce a filehash database to a list object
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/filehash.R
\name{registerFormatDB}
\alias{registerFormatDB}
\title{Register Database Format}
\usage{
registerFormatDB(name, funlist)
}
\arguments{
\item{name}{character, name of database format}

\item{funlist}{list of functions for creating and initializing a database format}
}
\description{
Register Database Format
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/coerce.R
\name{coerceDB1RDS}
\alias{coerceDB1RDS}
\alias{coerce,filehashDB1,filehashRDS-method}
\title{Coerce a filehash database}
\arguments{
\item{from}{a filehashDB1 database object}
}
\description{
Coerce a filehashDB1 database to filehashRDS format
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/dump.R
\name{dumpEnv}
\alias{dumpEnv}
\alias{dumpImage}
\alias{dumpObjects}
\alias{dumpDF}
\alias{dumpList}
\title{Dump Environment}
\usage{
dumpEnv(env, dbName)

dumpImage(dbName = "Rworkspace", type = NULL)

dumpObjects(
  ...,
  list = character(0),
  dbName,
  type = NULL,
  envir = parent.frame()
)

dumpDF(data, dbName = NULL, type = NULL)

dumpList(data, dbName = NULL, type = NULL)
}
\arguments{
\item{env}{an environment}

\item{dbName}{character, name of the filehash database}

\item{type}{type of filehash database to create}

\item{...}{R objects to be dumped to a filehash database}

\item{list, }{character vector of object names to be dumped}

\item{envir}{environment from which objects are dumped}

\item{data}{a data frame}
}
\value{
An object of class \code{"filehash"} is returned and a database is created.
}
\description{
Dump an enviroment to a filehash database
}
\details{
The \code{dumpEnv} function takes an environment and stores each element of the environment in a \code{filehash} database. Objects dumped to a database can later be loaded via \code{dbLoad} or can be accessed with \code{dbFetch}, \code{dbList}, etc. Alternatively, the \code{with} method can be used to evaluate code in the context of a database.  If a database with name \code{dbName} already exists, objects will be inserted into the existing database (and values for already-existing keys will be overwritten).

\code{dumpDF} is different in that each variable in the data frame is stored as a separate object in the database.  So each variable can be read from the database separately rather than having to load the entire data frame into memory.  \code{dumpList} works in a simlar way.
}
\section{Functions}{
\itemize{
\item \code{dumpImage()}: Dump the Global Environment (analogous to \code{save.image})

\item \code{dumpObjects()}: Dump named objects to a filehash database (analogous to \code{save})

\item \code{dumpDF()}: Dump data frame columns to a filehash database

\item \code{dumpList()}: Dump elements of a list to a filehash database

}}
